#include <hmg.ch>

#define CRLF2 CRLF + CRLF

PROCEDURE Main()

   LOCAL aSFoldNames := { "Desktop",;
						        "My Documents",;
						        "Programs",;
						        "Recent",;
						        "Start Menu",;
						        "Startup",;
						        "Favorites",;
						        "Fonts",;
						        "Net Hood",;
						        "Print Hood",;
						        "Send To",;
						        "Templates",; 
                          "All Users Desktop",;
						        "All Users StartMenu",;
						        "All Users Programs",;
						        "All Users Startup" }

   LOCAL aSFoldList                  
   
   nFrmWidth   := GetDesktopWidth() * .53
   nFrmHeight  := GetDesktopHeight() * .45
         
   DEFINE WINDOW frmSpFoldTest;
      AT 0, 0;
      WIDTH  nFrmWidth ;
      HEIGHT nFrmHeight ;
      TITLE "Special Folders Test" ;      
      MAIN 
      
      ON KEY ESCAPE ACTION ThisWindow.Release  
      
      DEFINE MAIN MENU
         
			POPUP 'Task'         
            ITEM '&Display Special Folders'  ACTION DispSFList( aSFoldNames, aSFoldList )
            ITEM '&Clear Screen'             ACTION ClearList() 
            ITEM '&About'                    ACTION DispAbout()
            SEPARATOR
            ITEM 'E&xit (Esc)'               ACTION ThisWindow.Release  
   		END POPUP
         
      END MENU      
      
   END WINDOW // frmSpFoldTest
   
   CENTER WINDOW frmSpFoldTest

   ACTIVATE WINDOW frmSpFoldTest

RETURN // (SysFoldTest)_Main()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE DispSFList( ;                   // Make and display special folders List
                      aSFNames,;
                      aSFList )
                      
   LOCAL aSFPaths := GetSpFPaths( aSFNames )
   
   IF !IsControlDefined( grdSpFolders, frmSpFoldTest )
      DEFINE GRID grdSpFolders 
         PARENT frmSpFoldTest
         ROW    10
         COL    10
         WIDTH  nFrmWidth - 40
         HEIGHT nFrmHeight - 70
         WIDTHS { nFrmWidth / 5, nFrmWidth / 5 * 3.7 }
         HEADERS {'Folder Name', 'Actual path'}
         FONTNAME "Verdana"
         FONTSIZE 9.5         
      END GRID // grdSpFolders
   ENDIF !IsControlDefined( ...
   
   aSFList := {}   
   AEVAL( aSFPaths, { | c1, i1 | AADD( aSFList, { aSFNames[ i1 ], c1 } ) } )
   
   frmSpFoldTest.grdSpFolders.DeleteAllItems()
   AEVAL( aSFList, { | a1 | frmSpFoldTest.grdSpFolders.AddItem( a1 ) } )
   frmSpFoldTest.grdSpFolders.Value := { 1, 1 }

RETURN // DispSFList()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
                      
PROCEDURE ClearList()            

   IF IsControlDefined( grdSpFolders, frmSpFoldTest )
      frmSpFoldTest.grdSpFolders.Release()
   ENDIF
   
RETURN // ClearList()               
   
*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
   
PROCEDURE DispAbout()       
               
   MsgInfo( "This work is based upon some info from" + CRLF +;
            "Visual FoxPro Wiki site( http://fox.wikis.com )" + CRLF +;
            "and builded on Windows Script Host (WSH) ." + CRLF2 +; 
            "Some notes about WSH from that site :" + CRLF2 +;
            "|   Windows Scripting Host is a Win32 application that allows" + CRLF +;
            "|   scripts to be run within the Windows environment." + CRLF +; 
            "|" + CRLF +; 
            "|   It is akin to the DOS Batch files, but much more powerful."  + CRLF +; 
            "|" + CRLF +; 
            "|   It is a COM Server so you can get a reference to its object model"  + CRLF +; 
            "|   in any Windows COM compliant language plus Windows"  + CRLF +;
            "|   (and DOS under Windows) can run the scripts itself." + CRLF +;
            "|" + CRLF +; 
            "|   Beware, however : " + CRLF +;
            "|" + CRLF +; 
            "|     - There are several releases of WSH that are not" + CRLF +;
            "|       completely compatible with one another." + CRLF +; 
            "|     - Not all Windows versions came with WSH"  + CRLF +;
            "|     - Even Windows versions that had WSH available may not have" + CRLF +; 
            "|       had WSH installed (or may have had it removed)." + CRLF2 +; 
            [A last note : some folders does not found into "special folders :"] + CRLF +; 
            "    Contacts" + CRLF +; 
            "    Downloads" + CRLF +; 
            "    Links" + CRLF +; 
            "    Music" + CRLF +; 
            "    Pictures" + CRLF +; 
            "    Saved Games" + CRLF +; 
            "    Searches", "About" )
            
RETURN // DispAbout()         
*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
   
   